
package com.xpand.java;

import java.lang.reflect.Method;

import org.testng.IInvokedMethod;
import org.testng.IInvokedMethodListener;
import org.testng.ITestContext;
import org.testng.ITestListener;
import org.testng.ITestNGMethod;
import org.testng.ITestResult;

/**
 * The listener interface for receiving XrayAnnotation events.
 * The Listener can be automatically invoked when TestNG tests are run by using ServiceLoader mechanism.
 * You can also add this listener to a TestNG Test class by adding
 * <code>@Listeners({com.xpand.java.XrayAnnotationListener.class})</code>
 * before the test class
 *
 * @see XrayAnnotation
 */
public class XrayAnnotationListener implements IInvokedMethodListener, ITestListener  {
    
    String requirement = null;
    String test = null;
    boolean testSuccess = true;
    
    
    /* (non-Javadoc)
     * @see org.testng.IInvokedMethodListener#beforeInvocation(org.testng.IInvokedMethod, org.testng.ITestResult)
     */
    public void beforeInvocation(IInvokedMethod method, ITestResult testResult) {

        System.out.println("bla");
        if(method.isTestMethod() && annotationPresent(method, XrayAnnotation.class) ) {
            System.out.println("This gets invoked before every TestNG Test that has @XrayAnnotation Annotation...");
            System.out.println("Requirement: " + requirement + " Test: " + test);
        }
    }

    
    private boolean annotationPresent(IInvokedMethod method, Class clazz) {
        boolean retVal = method.getTestMethod().getConstructorOrMethod().getMethod().isAnnotationPresent(clazz) ? true : false;
        return retVal;
    }
    
    /* (non-Javadoc)
     * @see org.testng.IInvokedMethodListener#afterInvocation(org.testng.IInvokedMethod, org.testng.ITestResult)
     */
    public void afterInvocation(IInvokedMethod method, ITestResult testResult) {
        if(method.isTestMethod()) {
            if(method.getClass().isAnnotationPresent(XrayAnnotation.class)) {
                System.out.println("This gets invoked after every TestNG Test that has @XrayAnnotation Annotation...");
                testResult.getTestContext().setAttribute("requirement",requirement);
                testResult.setAttribute("requirement",requirement);
                testResult.setAttribute("test",test);
                //testResult.getMethod().setAttribute("requirement",requirement);
            }
            if( !testSuccess ) {
                testResult.setStatus(ITestResult.FAILURE);
            }
        }
    }

    public void onTestStart(ITestResult result) {
        // TODO Auto-generated method stub
        
    }

    public void onTestSuccess(ITestResult result) {
        // TODO Auto-generated method stub
        
    }

    public void onTestFailure(ITestResult result) {
        // TODO Auto-generated method stub
        
    }

    public void onTestSkipped(ITestResult result) {
        // TODO Auto-generated method stub
        
    }

    public void onTestFailedButWithinSuccessPercentage(ITestResult result) {
        // TODO Auto-generated method stub
        
    }

    public void onStart(ITestContext context) {
        for(ITestNGMethod m1 : context.getAllTestMethods()) {
            if(m1.getConstructorOrMethod().getMethod().isAnnotationPresent(XrayAnnotation.class)) {
                //capture metadata information.
                requirement = m1.getConstructorOrMethod().getMethod().getAnnotation(XrayAnnotation.class).requirement();
                test = m1.getConstructorOrMethod().getMethod().getAnnotation(XrayAnnotation.class).test();
            }
        }
        
    }

    public void onFinish(ITestContext context) {
        // TODO Auto-generated method stub
        
    }
    

}